Index: trunk/src/emx/include/protocols/routed.h
===================================================================
--- trunk/src/emx/include/protocols/routed.h	(revision 338)
+++ trunk/src/emx/include/protocols/routed.h	(revision 339)
@@ -1,4 +1,3 @@
-/*- modified for gcc/os2 by bird 2003
- *
+/*-
  * Copyright (c) 1983, 1989, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -35,4 +34,7 @@
  *
  * $FreeBSD: src/include/protocols/routed.h,v 1.15 1999/09/05 17:43:31 peter Exp $
+ *
+ * @@level      FreeBSD 5.1
+ * @@changed    bird: TCPV40HDRS, TIMER_RATE from OS/2 headers.
  */
 
@@ -40,6 +42,4 @@
 #define	_ROUTED_H_
 #ifndef TCPV40HDRS
-
-/* OS2: This file is newer than the toolkit version, hope it doesn't do any harm. */
 
 #ifdef __cplusplus
Index: trunk/src/emx/include/protocols/rwhod.h
===================================================================
--- trunk/src/emx/include/protocols/rwhod.h	(revision 338)
+++ trunk/src/emx/include/protocols/rwhod.h	(revision 339)
@@ -1,4 +1,3 @@
-/* modified for gcc/os2 by bird 2003
- *
+/*
  * Copyright (c) 1983, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -33,4 +32,7 @@
  *
  *	@(#)rwhod.h	8.1 (Berkeley) 6/2/93
+ *
+ *  @@level     FreeBSD 5.1
+ *  @@changed   bird: TCPV40HDRS, #pragma pack(1) paranoia.
  */
 
Index: trunk/src/emx/include/protocols/talkd.h
===================================================================
--- trunk/src/emx/include/protocols/talkd.h	(revision 338)
+++ trunk/src/emx/include/protocols/talkd.h	(revision 339)
@@ -33,4 +33,7 @@
  *
  *	@(#)talkd.h	8.1 (Berkeley) 6/2/93
+ *
+ * @@level      FreeBSD 5.1
+ * @@changed    bird: TPCV40HDRS, #pragma pack(1) paranoia.
  */
 
Index: trunk/src/emx/include/protocols/timed.h
===================================================================
--- trunk/src/emx/include/protocols/timed.h	(revision 338)
+++ trunk/src/emx/include/protocols/timed.h	(revision 339)
@@ -33,4 +33,9 @@
  *
  *	@(#)timed.h	8.1 (Berkeley) 6/2/93
+ *
+ * $FreeBSD: src/include/protocols/timed.h,v 1.7 2002/02/03 12:00:05 markm Exp $
+ *
+ * @@level      FreeBSD 5.1
+ * @@changed    bird: TCPV40HDRS, #pragma pack(1) paranoia.
  */
 
@@ -48,9 +53,12 @@
 #pragma pack(1) /* OS2 paranoia */
 struct tsp {
-	u_char	tsp_type;
-	u_char	tsp_vers;
-	u_short	tsp_seq;
+	u_int8_t	tsp_type;
+	u_int8_t	tsp_vers;
+	u_int16_t	tsp_seq;
 	union {
-		struct timeval tspu_time;
+		struct {
+			int32_t	tv_sec;
+			int32_t	tv_usec;
+		} tspu_time;
 		char tspu_hopcnt;
 	} tsp_u;
@@ -94,5 +102,5 @@
 
 #ifdef TSPTYPES
-char *tsptype[TSPTYPENUMBER] =
+const char *tsptype[TSPTYPENUMBER] =
   { "ANY", "ADJTIME", "ACK", "MASTERREQ", "MASTERACK", "SETTIME", "MASTERUP",
   "SLAVEUP", "ELECTION", "ACCEPT", "REFUSE", "CONFLICT", "RESOLVE", "QUIT",
Index: trunk/src/emx/include/sys/cdefs.h
===================================================================
--- trunk/src/emx/include/sys/cdefs.h	(revision 338)
+++ trunk/src/emx/include/sys/cdefs.h	(revision 339)
@@ -1,4 +1,3 @@
-/*- modified for gcc/os2 by bird 2003
- *
+/*
  * Copyright (c) 1991, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -36,10 +35,13 @@
  *
  *	@(#)cdefs.h	8.8 (Berkeley) 1/9/95
- * $FreeBSD: src/sys/sys/cdefs.h,v 1.68 2002/10/21 20:50:30 mike Exp $
+ * $FreeBSD: src/sys/sys/cdefs.h,v 1.69 2003/04/18 18:59:34 bde Exp $
+ *
+ * @@level      FreeBSD 5.1
+ * @@changed    bird: Toolkit compatibility (_CDEFS_H_ and __TCPROTO()).
  */
 
 #ifndef	_SYS_CDEFS_H_
 #define	_SYS_CDEFS_H_
-#define _CDEFS_H_ /* compatability */
+#define _CDEFS_H_ /* bird: compatability */
 
 #if defined(__cplusplus)
@@ -192,5 +194,5 @@
 
 /* Compiler-dependent macros that rely on FreeBSD-specific extensions. */
-#if __FreeBSD_cc_version >= 300001 && __FreeBSD_cc_version < 500003
+#if __FreeBSD_cc_version >= 300001
 #define	__printf0like(fmtarg, firstvararg) \
 	    __attribute__((__format__ (__printf0__, fmtarg, firstvararg)))
@@ -199,5 +201,5 @@
 #endif
 
-#if 0 /* def __GNUC__ - ELF specific, so skip everything */
+#if 0 /* def __GNUC__ - bird: ELF specific, so skip everything */
 #define	__strong_reference(sym,aliassym)	\
 	extern __typeof (sym) aliassym __attribute__ ((__alias__ (#sym)));
@@ -235,5 +237,5 @@
  * more recent ELF binutils, we use .ident allowing the ID to be stripped.
  * Usage:
- *	__FBSDID("$FreeBSD: src/sys/sys/cdefs.h,v 1.68 2002/10/21 20:50:30 mike Exp $");
+ *	__FBSDID("$FreeBSD: src/sys/sys/cdefs.h,v 1.69 2003/04/18 18:59:34 bde Exp $");
  */
 #ifndef	__FBSDID
@@ -394,5 +396,5 @@
 #endif
 
-/* toolkit pollution */
+/* bird: toolkit pollution */
 #define __TCPPROTO(args) __P(args)
 
Index: trunk/src/emx/include/sys/stdint.h
===================================================================
--- trunk/src/emx/include/sys/stdint.h	(revision 339)
+++ trunk/src/emx/include/sys/stdint.h	(revision 339)
@@ -0,0 +1,108 @@
+/*-
+ * Copyright (c) 2001 Mike Barcroft <mike@FreeBSD.org>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/sys/sys/stdint.h,v 1.4 2002/08/21 16:20:01 mike Exp $
+ *
+ * @@level  FreeBSD 5.1
+ */
+
+#ifndef _SYS_STDINT_H_
+#define _SYS_STDINT_H_
+
+#include <sys/cdefs.h>
+#include <sys/_types.h>
+
+#include <machine/_stdint.h>
+
+#ifndef _INT8_T_DECLARED
+typedef	__int8_t		int8_t;
+#define	_INT8_T_DECLARED
+#endif
+
+#ifndef _INT16_T_DECLARED
+typedef	__int16_t		int16_t;
+#define	_INT16_T_DECLARED
+#endif
+
+#ifndef _INT32_T_DECLARED
+typedef	__int32_t		int32_t;
+#define	_INT32_T_DECLARED
+#endif
+
+#ifndef _INT64_T_DECLARED
+typedef	__int64_t		int64_t;
+#define	_INT64_T_DECLARED
+#endif
+
+#ifndef _UINT8_T_DECLARED
+typedef	__uint8_t		uint8_t;
+#define	_UINT8_T_DECLARED
+#endif
+
+#ifndef _UINT16_T_DECLARED
+typedef	__uint16_t		uint16_t;
+#define	_UINT16_T_DECLARED
+#endif
+
+#ifndef _UINT32_T_DECLARED
+typedef	__uint32_t		uint32_t;
+#define	_UINT32_T_DECLARED
+#endif
+
+#ifndef _UINT64_T_DECLARED
+typedef	__uint64_t		uint64_t;
+#define	_UINT64_T_DECLARED
+#endif
+
+typedef	__int_least8_t		int_least8_t;
+typedef	__int_least16_t		int_least16_t;
+typedef	__int_least32_t		int_least32_t;
+typedef	__int_least64_t		int_least64_t;
+
+typedef	__uint_least8_t		uint_least8_t;
+typedef	__uint_least16_t	uint_least16_t;
+typedef	__uint_least32_t	uint_least32_t;
+typedef	__uint_least64_t	uint_least64_t;
+
+typedef	__int_fast8_t		int_fast8_t;
+typedef	__int_fast16_t		int_fast16_t;
+typedef	__int_fast32_t		int_fast32_t;
+typedef	__int_fast64_t		int_fast64_t;
+
+typedef	__uint_fast8_t		uint_fast8_t;
+typedef	__uint_fast16_t		uint_fast16_t;
+typedef	__uint_fast32_t		uint_fast32_t;
+typedef	__uint_fast64_t		uint_fast64_t;
+
+typedef	__intmax_t		intmax_t;
+typedef	__uintmax_t		uintmax_t;
+
+#ifndef _INTPTR_T_DECLARED
+typedef	__intptr_t		intptr_t;
+typedef	__uintptr_t		uintptr_t;
+#define	_INTPTR_T_DECLARED
+#endif
+
+#endif /* !_SYS_STDINT_H_ */