Index: /trunk/icedtea-web/Config.kmk
===================================================================
--- /trunk/icedtea-web/Config.kmk	(revision 352)
+++ /trunk/icedtea-web/Config.kmk	(revision 352)
@@ -0,0 +1,90 @@
+## @file
+# Global Project Configuration File
+#
+
+#------------------------------------------------------------------------------
+# Global definitions
+#------------------------------------------------------------------------------
+
+PACKAGE_NAME       := icedtea-web
+PACKAGE_VERSION    := 1.1.2
+PACKAGE_STRING     := $(PACKAGE_NAME) $(PACKAGE_VERSION)
+PACKAGE_URL        := http://icedtea.classpath.org/wiki/IcedTea-Web
+
+FULL_VERSION       := $(PACKAGE_VERSION)
+
+IT_LANGUAGE_SOURCE_VERSION := 6
+IT_CLASS_TARGET_VERSION    := 6
+IT_JAVAC_SETTINGS           = -g -encoding utf-8 $(JAVACFLAGS) $(MEMORY_LIMIT) $(PREFER_SOURCE)
+IT_JAVACFLAGS               = $(IT_JAVAC_SETTINGS) -source $(IT_LANGUAGE_SOURCE_VERSION) -target $(IT_CLASS_TARGET_VERSION)
+
+BOOTSTRAP_JDK_RUNTIME   = $(PATH_BOOTSTRAP_JDK)/jre/lib/rt.jar;$(PATH_BOOTSTRAP_JDK)/jre/lib/jsse.jar
+
+NETX_RESOURCE_DIR       = $(PATH_ROOT)/netx/net/sourceforge/jnlp/resources
+
+INSTALL_DATA       := $(INSTALL) -m 644
+
+#
+# We need the jars in bootclasspath for a couple of reasons
+#  - we use classes (in the sun.applet package) loaded by the bootclassloader
+#    using another classloader to load classes from the same package causes an
+#    IllegalAccessException
+#  - we want full privileges
+#
+LAUNCHER_BOOTCLASSPATH  = -Xbootclasspath/a:$(datadir)/$(PACKAGE_NAME)/netx.jar$(RHINO_RUNTIME)
+PLUGIN_BOOTCLASSPATH    = -Xbootclasspath/a:$(datadir)/$(PACKAGE_NAME)/netx.jar;$(datadir)/$(PACKAGE_NAME)/plugin.jar$(RHINO_RUNTIME)
+
+# Fake update version to work with the Deployment Toolkit script used by Oracle
+# http://download.oracle.com/javase/tutorial/deployment/deploymentInDepth/depltoolkit_index.html
+JDK_UPDATE_VERSION  := 50
+
+#------------------------------------------------------------------------------
+# Tools
+#------------------------------------------------------------------------------
+
+#------------------------------------------------------------------------------
+# Common libraries referenced by components
+#------------------------------------------------------------------------------
+
+#------------------------------------------------------------------------------
+# General Stuff
+#------------------------------------------------------------------------------
+
+TEMPLATE_Cxx            = C++ sources
+TEMPLATE_Cxx_USES       =
+TEMPLATE_Cxx_TOOL       = GXX3OMF
+TEMPLATE_Cxx_INCS       = 
+TEMPLATE_Cxx_DEFS       = OS2EMX_PLAIN_CHAR
+
+ifn1of ($(EMXOMFLD_TYPE),WLINK wlink)
+TEMPLATE_Cxx_LDFLAGS    = -Zlinker '"DISABLE 1121"'
+endif
+
+# generate .sym files but don't put them in a separate dir
+TEMPLATE_Cxx_LD_DEBUG       = split
+TEMPLATE_Cxx_DEBUG_STAGE    = nul
+
+#------------------------------------------------------------------------------
+# Other Stuff
+#------------------------------------------------------------------------------
+
+#
+# Include a site-specific config for local overrides
+#
+ifndef LOCALCFG
+ LOCALCFG := $(wildcard $(PATH_ROOT)/LocalConfig.kmk)
+ ifneq ($(LOCALCFG),)
+  include $(LOCALCFG)
+ endif
+endif
+
+#------------------------------------------------------------------------------
+# Defaults
+#------------------------------------------------------------------------------
+
+PATH_MOZILLA_INCS          ?= $(PATH_ROOT)/../libs/mozilla/include
+MOZILLA_VERSION_COLLAPSED  ?= 11000000 # 11.0.0.0
+
+PATH_GLIB_INCS             ?= $(patsubst -I%,%,$(shell pkg-config --cflags-only-I glib-2.0))
+PATH_GLIB_LIBS             ?= $(patsubst -l%,%,$(shell pkg-config --libs-only-l glib-2.0))
+PATH_GLIB_LIBPATH          ?= $(patsubst -L%,%,$(shell pkg-config --libs-only-L glib-2.0))
Index: /trunk/icedtea-web/LocalConfig.kmk.tpl
===================================================================
--- /trunk/icedtea-web/LocalConfig.kmk.tpl	(revision 352)
+++ /trunk/icedtea-web/LocalConfig.kmk.tpl	(revision 352)
@@ -0,0 +1,26 @@
+## @file
+# Local Project Configuration File (Template)
+#
+# The local project configuration file is used to specify local paths to
+# external tools and libraries and also to optioanlly override the global
+# project configuration options.
+#
+# NOTES:
+#
+#   This file is a template! Copy it to a file named LocalConfig.kmk in 
+#   the same directory and modify the copy to fit your local environment.
+#
+#   All paths in this file are specified using forward slashes unless specified
+#   otherwise.
+#
+
+#
+# Base directory where all build output will go. The directory will be created
+# if does not exist. The default is "out" in the root of the source tree.
+#
+PATH_OUT_BASE := $(PATH_ROOT)/../$(PACKAGE_NAME)-build
+
+#
+# Path to bootstrap version of OpenJDK. Must be set.
+#
+PATH_BOOTSTRAP_JDK := $(PATH_ROOT)/../openjdk/build-product-release/j2sdk-image
Index: /trunk/icedtea-web/Makefile.kmk
===================================================================
--- /trunk/icedtea-web/Makefile.kmk	(revision 352)
+++ /trunk/icedtea-web/Makefile.kmk	(revision 352)
@@ -0,0 +1,13 @@
+## @file
+#
+
+SUB_DEPTH = .
+include $(KBUILD_PATH)/subheader.kmk
+
+#
+# Include sub-makefiles.
+#
+include $(PATH_SUB_CURRENT)/netx/Makefile.kmk
+include $(PATH_SUB_CURRENT)/plugin/Makefile.kmk
+
+include $(FILE_KBUILD_SUB_FOOTER)
Index: /trunk/icedtea-web/plugin/Makefile.kmk
===================================================================
--- /trunk/icedtea-web/plugin/Makefile.kmk	(revision 352)
+++ /trunk/icedtea-web/plugin/Makefile.kmk	(revision 352)
@@ -0,0 +1,12 @@
+## @file
+#
+
+SUB_DEPTH = ..
+include $(KBUILD_PATH)/subheader.kmk
+
+#
+# Include sub-makefiles.
+#
+include $(PATH_SUB_CURRENT)/icedteanp/Makefile.kmk
+
+include $(FILE_KBUILD_SUB_FOOTER)
Index: /trunk/icedtea-web/plugin/icedteanp/Makefile.kmk
===================================================================
--- /trunk/icedtea-web/plugin/icedteanp/Makefile.kmk	(revision 352)
+++ /trunk/icedtea-web/plugin/icedteanp/Makefile.kmk	(revision 352)
@@ -0,0 +1,54 @@
+## @file
+#
+
+SUB_DEPTH = ../..
+include $(KBUILD_PATH)/subheader.kmk
+
+DLLS               += npicedt
+npicedt_TEMPLATE    = Cxx
+npicedt_INCS        = $(PATH_MOZILLA_INCS) $(PATH_GLIB_INCS)
+npicedt_DEFS        = JDK_UPDATE_VERSION=$(JDK_UPDATE_VERSION) \
+                      MOZILLA_VERSION_COLLAPSED=$(MOZILLA_VERSION_COLLAPSED)
+npicedt_CXXFLAGS    = -DPLUGIN_NAME="IcedTea-Web Plugin" \
+                      -DPLUGIN_VERSION="IcedTea-Web $(FULL_VERSION)" \
+                      -DPACKAGE_URL="$(PACKAGE_URL)" \
+                      -DICEDTEA_WEB_JRE="$(SYSTEM_JRE_DIR)" \
+                      -DPLUGIN_BOOTCLASSPATH="$(PLUGIN_BOOTCLASSPATH)"
+npicedt_LIBS        = $(PATH_GLIB_LIBS)
+npicedt_LIBPATH     = $(PATH_GLIB_LIBPATH)
+
+npicedt_SOURCES     = \
+    IcedTeaNPPlugin.cc \
+    IcedTeaScriptablePluginObject.cc \
+    IcedTeaJavaRequestProcessor.cc \
+    IcedTeaPluginRequestProcessor.cc \
+    IcedTeaPluginUtils.cc
+
+# Unsorted stuff from Makefile.in
+
+#@ENABLE_PLUGIN_TRUE@ICEDTEAPLUGIN_CLEAN = clean-IcedTeaPlugin
+#@ENABLE_PLUGIN_TRUE@LIVECONNECT_DIR = netscape sun/applet
+#@ENABLE_PLUGIN_TRUE@PLUGIN_DIR = $(abs_top_builddir)/plugin/icedteanp
+#@ENABLE_PLUGIN_TRUE@PLUGIN_SRCDIR = $(abs_top_srcdir)/plugin/icedteanp
+#@ENABLE_PLUGIN_TRUE@LIVECONNECT_SRCS = $(PLUGIN_SRCDIR)/java
+#@ENABLE_PLUGIN_TRUE@ICEDTEAPLUGIN_TARGET = $(PLUGIN_DIR)/IcedTeaPlugin.so stamps/liveconnect-dist.stamp
+#@ENABLE_PLUGIN_TRUE@PLUGIN_PKGS = sun.applet netscape.security netscape.javascript
+
+#@ENABLE_PLUGIN_TRUE@	${INSTALL_PROGRAM} $(PLUGIN_DIR)/IcedTeaPlugin.so $(DESTDIR)$(libdir)
+#@ENABLE_PLUGIN_TRUE@	${INSTALL_DATA} $(abs_top_builddir)/liveconnect/lib/classes.jar $(DESTDIR)$(datadir)/$(PACKAGE_NAME)/plugin.jar
+
+#@ENABLE_PLUGIN_TRUE@stamps/plugin-tests.stamp: $(PLUGIN_TEST_SRCS) stamps/plugin.stamp
+#@ENABLE_PLUGIN_TRUE@	mkdir -p plugin/tests/LiveConnect
+#@ENABLE_PLUGIN_TRUE@	$(BOOT_DIR)/bin/javac $(IT_JAVACFLAGS) \
+#@ENABLE_PLUGIN_TRUE@	 -d plugin/tests/LiveConnect \
+#@ENABLE_PLUGIN_TRUE@	 -classpath liveconnect/lib/classes.jar \
+#@ENABLE_PLUGIN_TRUE@	 $(PLUGIN_TEST_SRCS) ;
+#@ENABLE_PLUGIN_TRUE@	$(BOOT_DIR)/bin/jar cf plugin/tests/LiveConnect/PluginTest.jar \
+#@ENABLE_PLUGIN_TRUE@	  plugin/tests/LiveConnect/*.class ;
+#@ENABLE_PLUGIN_TRUE@	cp -pPR $(SRC_DIR_LINK) $(abs_top_srcdir)/plugin/tests/LiveConnect/*.{js,html} \
+#@ENABLE_PLUGIN_TRUE@	  plugin/tests/LiveConnect ;
+#@ENABLE_PLUGIN_TRUE@	echo "Done. Now launch \"firefox file://`pwd`/index.html\"" ;
+#@ENABLE_PLUGIN_TRUE@	mkdir -p stamps
+#@ENABLE_PLUGIN_TRUE@	touch stamps/plugin-tests.stamp
+
+include $(FILE_KBUILD_SUB_FOOTER)